/*
CSTLEMMA - trainable lemmatiser using word-end inflectional rules

Copyright (C) 2002, 2004  Center for Sprogteknologi, University of Copenhagen

This file is part of CSTLEMMA.

CSTLEMMA is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

CSTLEMMA is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with CSTLEMMA; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef TEXT_H
#define TEXT_H

#include <stdio.h>
#include "defines.h"

class unTaggedWord;
class taggedWord;
class basefrm;
/*
class flex;
class taggedWord;
class dictionary;
*/

class taggedText
    {
    private:
#if QSORT
        union
            {
            unTaggedWord ** unTaggedWords;
            taggedWord ** TaggedWords;
            } u;
#else
        unTaggedWord * Root;
#endif
        const unTaggedWord ** unsorted;
        bool sorted;
        unsigned long int total;
        unsigned long int reducedtotal;
        basefrm ** basefrmarrD;
        basefrm ** basefrmarrL;
        bool InputHasTags;
        int listLemmas;
    public:
#if !QSORT
        basefrm ** D;
        basefrm ** L;
        int cntD;
        int cntL;
        int newcnt;
        int newcntTypes;
        int aConflict;
        int aConflictTypes;
#endif
        static bool setFormat(const char * format,const char * bformat,const char * Bformat,bool InputHasTags);
        void unknownWords(FILE * fpo,/*FILE * fpnew,FILE * fpconflict,*/const char * Sep,
            unsigned long int & totcnt,unsigned long int & totcntTypes,
            unsigned long int & newcnt,unsigned long int & newcntTypes,
            unsigned long int & aConflict,unsigned long int & aConflictTypes,bool SortInput,bool SortOutput,int UseLemmaFreqForDisambiguation,bool nice);
//        int itsReducedTotal()const{return reducedtotal;}
        taggedText(FILE * fpi,bool InputHasTags,int listLemmas,char * Iformat,int keepPunctuation,bool nice,unsigned long int size,bool treatSlashAsAlternativeSeparator);
        ~taggedText();
#if QSORT
        void sort();
#endif
//        taggedWord ** itsTaggedWords()const{return TaggedWords;} 
//        const taggedWord ** itsUnsortedTaggedWords()const{return unsorted;} 
//        bool Sorted(){return sorted;}
        void createUnTaggedAlternatives(char * w);
        void createUnTagged(char * w);
        void createTaggedAlternatives(char * w, const char * tag);
        void createTagged(char * w, const char * tag);
    };


#endif
